package org.playonline.network.client.http;

import org.playonline.network.client.UGASPClient;
import org.playonline.network.datatransmission.DataTransmissionMgr;
import org.playonline.network.datatransmission.http.DataTransmissionMgrHttp;
import org.playonline.network.id.ID;
import org.playonline.network.lobby.LobbyMgr;
import org.playonline.network.lobby.http.LobbyMgrHttp;

import android.util.Log;

public class UGASPClientHttp implements UGASPClient {
	
	// Tetra 88.173.211.22
	// TSP 157.159.110.47 -- 
	// CNAM 5è 163.173.231.9 + www.playonline-academique.fr.st
	public static final String uGASPDefaultAddress = "127.0.0.1";
	public static String uGASPServletUrl;// = "http://163.173.231.9:8080/uGASP";
	
	private final ID clientID;
	private final LobbyMgr lobbyMgr;
	private final DataTransmissionMgr dataTransmissionMgr;
	
	public UGASPClientHttp(){
		clientID = new ID();
		lobbyMgr = new LobbyMgrHttp(this);
		dataTransmissionMgr = new DataTransmissionMgrHttp(this);
	}
	
	public ID getID() {
		return clientID;
	}

	public LobbyMgr getLobbyMgr() {
		return lobbyMgr;
	}

	public DataTransmissionMgr getDataTransmissionMgr() {
		return dataTransmissionMgr;
	}

	public void onQuitEvent(short actorSessionID) {}

	public void onJoinEvent(short actorSessionID, String username) {}

	public void onEndEvent(short actorSessionID) {}

	public void onStartEvent(short actorSessionID) {}

	public void handleDisconnection() {
		Log.i(this.getClass().getSimpleName(),"********** Management of deconnection is application dependant **********");
		getDataTransmissionMgr().setDisconnected(true);
	}
	
	public static void setUGASPUrl(String url){
		uGASPServletUrl = url;
		LobbyMgrHttp.updateUGASPUrl();
		DataTransmissionMgrHttp.updateUGASPUrl();
	}

}
