package org.playonline.network.connectedclients;

/*
 *	This class is used to deal with connected clients.
 *	When onJoin(int actorSessionID,String username) method is called, i.e. if any client has called the joinAI(int sID, int aIID) method, 
 *	its actorSessionID and its username are used to instanciate the following class. 
 *   Then, this instance is stored in the connectedClients vector, untill onQuit(int actorSessionID) is called:
 *	the ConnectedClient which earns this actorSessionID is removed from connectedClients' vector.
 */
public class ConnectedClient{

	private short actorSessionID;
	private String username;

	public ConnectedClient(short actorSessionID,String username){
		this.actorSessionID = actorSessionID;
		this.username = username;
	}

	public short getActorSessionID(){
		return actorSessionID;
	}

	public String getUsername(){
		return username;
	}

	public boolean equals(Object o){
		if(!(o instanceof ConnectedClient))
			return false;
		ConnectedClient client = (ConnectedClient)o;
		return (client.actorSessionID == actorSessionID) && (client.username.equals(username));
	}

	public int hashCode(){
		// Values 17 and 37 are from recommendation 8
		// in the book "Effective Java - programming language guide" by Joshua Block.
		int result = 17;
		result = 37 * result + actorSessionID;
		result = 37 * result + username.hashCode();
		return result;
	}
}