package org.playonline.network.tools;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.HttpURLConnection;

public class ConnectionTools {

	private ConnectionTools(){}
	
	public static void closeConnection(HttpURLConnection connection){
		// closing connection if needed
		if (connection != null){
			// get a lock on the connection
			synchronized (connection) {
				try{
					// closing connection
					connection.disconnect();
					connection= null; 
				} catch(Exception e){
					e.printStackTrace();
				}
			}
		}
	}

	
	public static void closeDataOutputStream(DataOutputStream dos){
		if(dos != null){
			try {
				dos.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}


	public static void closeDataInputStream(DataInputStream dis){
		if(dis != null){
			try {
				dis.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	
}
