package org.playonline.ui.basic.dialog;

import java.util.HashMap;
import java.util.Map;

import org.playonline.ui.basic.R;
import org.playonline.ui.basic.interaction.InGameProgress;

public class InGameDialogFrameData {
	
	public static final short LEAVE_DIALOG 	= -1;
	
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_0 	= initDialogFrameData0();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_1 	= initDialogFrameData1();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_2 	= initDialogFrameData2();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_3 	= initDialogFrameData3();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_4 	= initDialogFrameData4();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_5 	= initDialogFrameData5();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_6 	= initDialogFrameData6();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_7 	= initDialogFrameData7();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_8 	= initDialogFrameData8();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_9 	= initDialogFrameData9();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_10 	= initDialogFrameData10();
	public static final InGameDialogFrameData DIALOG_FRAME_DATA_11 	= initDialogFrameData11();
	
	private static final Map<Short, InGameDialogFrameData> dialogFrameDataByID;
	
	
	private short id;
	private int otherCharacterDrawable;
	private int lowerCharacterDrawable;
	private CharSequence title;
	private CharSequence otherCharacterText;
	private CharSequence firstOptionText;
	private CharSequence secondOptionText;
	private CharSequence thirdOptionText;
	private CharSequence fourthOptionText;
	private short firstOptionFollowingDialogId;
	private short secondOptionFollowingDialogId;
	private short thirdOptionFollowingDialogId;
	private short fourthOptionFollowingDialogId;
	private boolean keepOptionTextViewEnabled = false;// is it enough for all our cases ? 
	
	static{
		dialogFrameDataByID = new HashMap<Short, InGameDialogFrameData>();
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_0.id, DIALOG_FRAME_DATA_0);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_1.id, DIALOG_FRAME_DATA_1);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_2.id, DIALOG_FRAME_DATA_2);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_3.id, DIALOG_FRAME_DATA_3);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_4.id, DIALOG_FRAME_DATA_4);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_5.id, DIALOG_FRAME_DATA_5);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_6.id, DIALOG_FRAME_DATA_6);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_7.id, DIALOG_FRAME_DATA_7);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_8.id, DIALOG_FRAME_DATA_8);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_9.id, DIALOG_FRAME_DATA_9);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_10.id, DIALOG_FRAME_DATA_10);
		dialogFrameDataByID.put(DIALOG_FRAME_DATA_11.id, DIALOG_FRAME_DATA_11);
	}
	
	
	private static InGameDialogFrameData initDialogFrameData0() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = InGameProgress.mayorFirstDialog;
		data.title = "Agent \"X\"";
		data.otherCharacterDrawable =  R.drawable.perso_homme;
		data.lowerCharacterDrawable =  R.drawable.intervenant_maire;
		data.otherCharacterText = 	"Bonjour Monsieur, je suis l'agent \"X\". " +
									"Mon équipe et moi même sommes venu le plus rapidement possible pour répondre à votre appel. " +
									"Pouvez vous nous donner plus de détails et nous faire un point sur l'évolution de la situation ici ?";
		data.secondOptionText = "Suivant";
		data.secondOptionFollowingDialogId = 1;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData1() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 1;
		// option text view should stay enabled
		data.keepOptionTextViewEnabled = true;
		data.title = "Maire de l'île";
		data.otherCharacterDrawable = R.drawable.intervenant_maire;
		data.lowerCharacterDrawable = R.drawable.perso_homme;
		
		/* data.otherCharacterText = 	"Bonjour, je suis le Maire, " +
									"Kevin Bradford. Je vous remercie tout d'abord pour votre réactivité. " +
									"La situation ici est des plus déroutante et l'inquiétude gagne désormais toute la population." +
									"Pour être direct, un mal étrange semble se propager sur notre île. " +
									"Cela a commencé dans nos champs agricoles et maintenant nous commençons à recenser des cas étranges au sein même de la population. " +
									"Je crains que nous n'ayons à faire à une contamination massive de l'île, " +
									"mais je n'ai aucunes preuves de ce que j'avance. Votre aide nous sera précieuse. " +
									"Mais si d'ici 3 jours, vous n'avez pas trouver ce qui se passe, je serais obligé de décréter l'état d'urgence et j'isolerai l'île du reste du monde.";*/
		data.otherCharacterText = 	"Bonjour, je suis le Maire, " +
		"Kevin Bradford. Un mal étrange semble se propager sur notre île. " +
		"Je crains que nous n'ayons à faire à une contamination massive de l'île, " +
		"Si d'ici 3 jours, vous n'avez pas trouver ce qui se passe, j'isolerai l'île du reste du monde.";
		data.firstOptionText = "Quels sont les principaux symptômes ?";
		data.secondOptionText = "Avez-vous une idée du point de départ de l'épidémie ?";
		data.thirdOptionText = "Des humains touché, dites m'en plus ?";
		data.fourthOptionText = "Pouvons-nous circuler librement sur toute l'île ?";
		data.firstOptionFollowingDialogId = 2;
		data.secondOptionFollowingDialogId = 3;
		data.thirdOptionFollowingDialogId = 4;
		data.fourthOptionFollowingDialogId = 5;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData2() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 2;
		data.title = "Maire de l'île";
		data.otherCharacterDrawable = R.drawable.intervenant_maire;
		data.lowerCharacterDrawable = R.drawable.perso_homme;
		data.otherCharacterText = 	"Je ne suis pas un spécialiste, " +
									"mais il semble que l'on constate une dégradation des plantes. " +
									"Il faudrait que vous interrogiez les responsables agricoles. ";
		data.firstOptionText = "Quels sont les principaux symptômes ?";
		data.secondOptionText = "Avez-vous une idée du point de départ de l'épidémie ?";
		data.thirdOptionText = "Des humains touché, dites m'en plus ?";
		data.fourthOptionText = "Pouvons-nous circuler librement sur toute l'île ?";
		data.secondOptionFollowingDialogId = 3;
		data.thirdOptionFollowingDialogId = 4;
		data.fourthOptionFollowingDialogId = 5;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData3() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 3;
		data.title = "Maire de l'île";
		data.otherCharacterDrawable = R.drawable.intervenant_maire;
		data.lowerCharacterDrawable = R.drawable.perso_homme;
		data.otherCharacterText = "D'après les rapports, la zone nord de l'île serait le point Zéro. Mais il faudra faire plus d'investigations.";
		data.firstOptionText = "Quels sont les principaux symptômes ?";
		data.secondOptionText = "Avez-vous une idée du point de départ de l'épidémie ?";
		data.thirdOptionText = "Des humains touché, dites m'en plus ?";
		data.fourthOptionText = "Pouvons-nous circuler librement sur toute l'île ?";
		data.firstOptionFollowingDialogId = 2;
		data.thirdOptionFollowingDialogId = 4;
		data.fourthOptionFollowingDialogId = 5;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData4() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 4;
		data.title = "Maire de l'île";
		data.otherCharacterDrawable = R.drawable.intervenant_maire;
		data.lowerCharacterDrawable = R.drawable.perso_homme;
		data.otherCharacterText = 	"Plusieurs personnes se sont pleins de maux de têtes et de vomissements, " +
									"vous en saurez plus en allant à l'hôpital.";
		data.firstOptionText = "Quels sont les principaux symptômes ?";
		data.secondOptionText = "Avez-vous une idée du point de départ de l'épidémie ?";
		data.thirdOptionText = "Des humains touché, dites m'en plus ?";
		data.fourthOptionText = "Pouvons-nous circuler librement sur toute l'île ?";
		data.firstOptionFollowingDialogId = 2;
		data.secondOptionFollowingDialogId = 3;
		data.fourthOptionFollowingDialogId = 5;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData5() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 5;
		data.title = "Maire de l'île";
		data.otherCharacterDrawable = R.drawable.intervenant_maire;
		data.lowerCharacterDrawable = R.drawable.perso_homme;
		data.otherCharacterText = 	"Oui, voici une autorisation spéciale, " +
									"elle vous permettra d'accéder partout et de réquisitionner tout moyen de transport qui pourrait vous être utile.";
		data.firstOptionText = "Quels sont les principaux symptômes ?";
		data.secondOptionText = "Avez-vous une idée du point de départ de l'épidémie ?";
		data.thirdOptionText = "Des humains touché, dites m'en plus ?";
		data.fourthOptionText = "Pouvons-nous circuler librement sur toute l'île ?";
		data.firstOptionFollowingDialogId = 2;
		data.secondOptionFollowingDialogId = 3;
		data.fourthOptionFollowingDialogId = 5;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData6() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = InGameProgress.fieldsWorkerFirstDialog;
		data.title = "Agent \"X\"";
		data.otherCharacterDrawable =  R.drawable.perso_homme;
		data.lowerCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.otherCharacterText = 	"Bonjour Mademoiselle, mon équipe et moi-même enquêtons en ce moment sur les étranges évènements " +
									"qui semblent avoir des conséquences négatives sur les récoltes.";
		data.secondOptionText = "Suivant";
		data.secondOptionFollowingDialogId = 7;
		return data;
	}
	
	private static InGameDialogFrameData initDialogFrameData7() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 7;
		// option text view should stay enabled
		data.keepOptionTextViewEnabled = true;
		data.title = "Responsable agricole";
		data.otherCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.lowerCharacterDrawable =  R.drawable.perso_homme;
		data.otherCharacterText = 	"Ha oui, et qu’est ce qui me prouve ce que vous dites ? Les curieux dans votre genre, j’en croise tout les jours ! " +
									"Si vous n’avez pas mieux à me dire, laissez-moi j’ai du travail.";
		// needed to remove former "Suivant" option text
		data.secondOptionText = "";
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData8() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 8;
		data.title = "Responsable agricole";
		data.otherCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.lowerCharacterDrawable =  R.drawable.perso_homme;
		data.otherCharacterText = 	"Ha, ok, ça change tout. Je vous écoute, que voulez vous savoir ?";
		data.firstOptionText = " Décrivez-moi la situation.";
		data.secondOptionText = " Quand cela a-t-il commencé ?";
		data.thirdOptionText = "Peut-on faire quelques prélèvements ?";
		data.firstOptionFollowingDialogId = 9;
		data.secondOptionFollowingDialogId = 10;
		data.fourthOptionFollowingDialogId = 11;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData9() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 9;
		data.title = "Responsable agricole";
		data.otherCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.lowerCharacterDrawable =  R.drawable.perso_homme;
		data.otherCharacterText = 	"On vous a parlé de dégradation, mais c’est inexact. " +
									"En fait, il semble que quelque chose ai empêché la croissance naturelle des plantes. " +
									"Je dirai que quelque chose c’est produit dans le cycle et cela a été catastrophique. " +
									"Mais je ne sais pas quoi.";
		data.firstOptionText = " Décrivez-moi la situation.";
		data.secondOptionText = " Quand cela a-t-il commencé ?";
		data.thirdOptionText = "Peut-on faire quelques prélèvements ?";
		data.firstOptionFollowingDialogId = 9;
		data.secondOptionFollowingDialogId = 10;
		data.thirdOptionFollowingDialogId = 11;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData10() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 10;
		data.title = "Responsable agricole";
		data.otherCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.lowerCharacterDrawable =  R.drawable.perso_homme;
		data.otherCharacterText = 	"Exactement, difficile à dire, je dirai plutôt que le problème est que cela n’a pas commencé.";
		data.firstOptionText = " Décrivez-moi la situation.";
		data.secondOptionText = " Quand cela a-t-il commencé ?";
		data.thirdOptionText = "Peut-on faire quelques prélèvements ?";
		data.firstOptionFollowingDialogId = 9;
		data.secondOptionFollowingDialogId = 10;
		data.thirdOptionFollowingDialogId = 11;
		return data;
	}
	
	
	private static InGameDialogFrameData initDialogFrameData11() {
		InGameDialogFrameData data = new InGameDialogFrameData();
		data.id = 11;
		data.title = "Responsable agricole";
		data.otherCharacterDrawable =  R.drawable.intervenant_responsable_agricole;
		data.lowerCharacterDrawable =  R.drawable.perso_homme;
		data.otherCharacterText = 	" Bien sûr, si vous avez le matériel nécessaire.";
		data.firstOptionText = " Décrivez-moi la situation.";
		data.secondOptionText = " Quand cela a-t-il commencé ?";
		data.thirdOptionText = "Peut-on faire quelques prélèvements ?";
		data.firstOptionFollowingDialogId = 9;
		data.secondOptionFollowingDialogId = 10;
		data.thirdOptionFollowingDialogId = 11;
		return data;
	}
	
	
	public static InGameDialogFrameData getDialogFrameDataByID(short id){
		return dialogFrameDataByID.get(Short.valueOf(id));
	}
	

	public short getId() {
		return id;
	}
	
	
	public CharSequence getTitle(){
		return title;
	}
	
	public int getOtherCharacterDrawable() {
		return otherCharacterDrawable;
	}
	
	public int getLowerCharacterDrawable(){
		return lowerCharacterDrawable;
	}
	

	public CharSequence getOtherCharacterText() {
		return otherCharacterText;
	}
	
	
	public CharSequence getFirstOptionText() {
		return firstOptionText;
	}
	
	
	public CharSequence getSecondOptionText() {
		return secondOptionText;
	}
	
	
	public CharSequence getThirdOptionText() {
		return thirdOptionText;
	}

	
	public CharSequence getFourthOptionText() {
		return fourthOptionText;
	}

	
	public short getFirstOptionFollowingDialogId() {
		return firstOptionFollowingDialogId;
	}

	
	public short getSecondOptionFollowingDialogId() {
		return secondOptionFollowingDialogId;
	}

	
	public short getThirdOptionFollowingDialogId() {
		return thirdOptionFollowingDialogId;
	}

	
	public short getFourthOptionFollowingDialogId() {
		return fourthOptionFollowingDialogId;
	}
	
	public boolean shallOptionTextViewStayEnabled(){
		return keepOptionTextViewEnabled;
	}
}
