package org.playonline.ui.basic.map.handler;

import android.os.Bundle;
import android.os.Message;

public class MapViewMessage {

	public static final String LATITUDE_E6_KEY 				= "latitudeE6";
	public static final String LONGITUDE_E6_KEY 			= "longitudeE6";
	public static final String ACTOR_SESSION_ID_KEY 		= "actorSessionId";
	public static final String PLAYER_NAME_KEY 				= "playerName";
	public static final String ELEMENT_NAME_KEY 			= "elementName";
	public static final String ELEMENT_DESCRIPTION_KEY 		= "elementDescription";
	public static final String IS_GROUP_KEY 				= "isGroup";
	public static final String MEMBERS_NAMES_ARRAY_KEY		= "membersNamesArray";
	public static final String TEXT_VIEW_INDEX_KEY 			= "textViewIndex";
	public static final String DIALOG_FRAME_ID_KEY 			= "dialogFrameId";
	public static final String HIDDEN_ELEMENT_MARKER_KEY	= "hiddenElementMarker";
	public static final String HIDDEN_ELEMENT_HASHCODE_KEY	= "hiddenElementHashCode";
	public static final String SEND_TRANSPORT_POINT_KEY		= "pointsToSend";
	
	
	
	public static Message updateCharactersOverlays(){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.UPDATE_CHARACTERS_OVERLAY_WHAT;
		return message;
	}
	
	
	public static Message displayShortToastMessage(String toast){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.SHORT_TOAST_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putCharSequence(MapViewHandler.DEFAULT_BUNDLE_KEY, toast);
		message.setData(b);
		return message;
	}
	
	
	public static Message displayLongToastMessage(String toast){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.LONG_TOAST_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putCharSequence(MapViewHandler.DEFAULT_BUNDLE_KEY, toast);
		message.setData(b);
		return message;
	}
	
	
	public static Message displayAlertMessage(String alert){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.ALERT_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putCharSequence(MapViewHandler.DEFAULT_BUNDLE_KEY, alert);
		message.setData(b);
		return message;
	}
	
	
	public static Message displayCreateInstanceProgressDialog(){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.CREATE_INSTANCE_PROGRESS_WHAT;
		return message;
	}
	
	
	public static Message displayJoinInstanceProgressDialog(){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.JOIN_INSTANCE_PROGRESS_WHAT;
		return message;
	}
	
	public static Message cancelProgressDialog(){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.CANCEL_PROGRESS_WHAT;
		return message;
	}
	
	
	public static Message showDialogMessage(short dialogId){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.SHOW_DIALOG_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putShort(MapViewHandler.DEFAULT_BUNDLE_KEY, dialogId);
		message.setData(b);
		return message;
	}
	
	public static Message updateDialogFrameMessage(int textViewIndex, short dialogId){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.UDPATE_DIALOG_FRAME_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putShort(DIALOG_FRAME_ID_KEY, dialogId);
		b.putInt(TEXT_VIEW_INDEX_KEY, textViewIndex);
		message.setData(b);
		return message;
	}


	public static Message cancelDialogFrameMessage() {
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.CANCEL_DIALOG_FRAME_WHAT;
		return message;
	}

	
	public static Message addHiddenElementOverlayMessage(int hiddenElementHashCode) {
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.ADD_HIDDEN_ELEMENT_OVERLAY_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putInt(HIDDEN_ELEMENT_HASHCODE_KEY, hiddenElementHashCode);
		message.setData(b);
		return message;
	}
	

	public static Message removeHiddenElementOverlayMessage(int hiddenElementHashCode) {
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.REMOVE_HIDDEN_ELEMENT_OVERLAY_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putInt(HIDDEN_ELEMENT_HASHCODE_KEY, hiddenElementHashCode);
		message.setData(b);
		return message;
	}
	
	
	public static Message catchHiddenElement(String name, String description, int marker, int hiddenElementHashCode) {
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.CATCH_HIDDEN_ELEMENT_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putString(ELEMENT_NAME_KEY, name);
		b.putString(ELEMENT_DESCRIPTION_KEY, description);
		b.putInt(HIDDEN_ELEMENT_MARKER_KEY, marker);
		b.putInt(HIDDEN_ELEMENT_HASHCODE_KEY, hiddenElementHashCode);
		message.setData(b);
		return message;
	}
	
	
	public static Message animateToMyLocationMessage() {
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.ANIMATE_TO_MYLOCATION_WHAT;
		return message;
	}
	
	
	public static Message sendTransportPointsMessage(short pointsToSend){
		// create message
		Message message = new Message();
		// set what
		message.what = MapViewWhat.SEND_TRANSPORT_POINTS_WHAT;
		// create and set data
		Bundle b = new Bundle();
		b.putShort(SEND_TRANSPORT_POINT_KEY, pointsToSend);
		message.setData(b);
		return message;
	}
	
	
}
