package org.playonline.ui.basic.map.overlay;

import java.util.ArrayList;

import org.playonline.ui.basic.R;
import org.playonline.ui.basic.interaction.InGameProgress;
import org.playonline.ui.basic.map.PlayOnlineGeoPoint;
import org.playonline.ui.basic.map.PlayOnlineMapActivity;

import android.graphics.drawable.Drawable;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;


public class MyCharacterOverlay extends ItemizedOverlay<OverlayItem> implements CharacterOverlay{

	private static int MARKER = R.drawable.ic_maps_indicator_current_position;
	
	private final ArrayList<OverlayItem> mOverlays;
	private final PlayOnlineMapActivity mapActivity;
	private final GeoPoint currentLocation;
	private final OverlayItem overlayItem;
	
	
	public MyCharacterOverlay(PlayOnlineMapActivity mapActivity, GeoPoint location) {
		super(boundCenterBottom(mapActivity.getResources().getDrawable(MARKER)));
		mOverlays = new ArrayList<OverlayItem>();
		this.mapActivity = mapActivity;
		this.currentLocation = location;
		overlayItem = new OverlayItem(currentLocation, "", "");
		this.addOverlay(overlayItem);
	}

	
	public static void changeMarker(int drawable){
		MARKER = drawable;
	}
	
	public void addOverlay(OverlayItem overlay) {
		mOverlays.add(overlay);
		populate();
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}

	@Override
	protected boolean onTap(int index) {
		if(!InGameProgress.missionMayorUnblocked){
			InGameProgress.missionMayorUnblocked = true;
			// create a new place
			mapActivity.unblockNewPlace(R.drawable.mairie_tetra, PlayOnlineGeoPoint.MAYOR_AREA, "Ile Graham", "Mairie",InGameProgress.mayorFirstDialog);
			// show this new place
			mapActivity.getNewElementsAlertDialog().displayNewPlace("Mission 1 : Rencontrer les autorités, en la personne du Maire de l'île.", PlayOnlineGeoPoint.MAYOR_AREA, null);			
		}
		return true;
	}
	
	public void setAlpha(int alpha){
		Drawable marker = mapActivity.getResources().getDrawable(R.drawable.ic_maps_indicator_current_position);
		marker.setAlpha(alpha);
		boundCenterBottom(marker);
	}
	
	public GeoPoint getLocation(){
		return currentLocation;
	}
	
	
	public ItemizedOverlay<OverlayItem> getItemizedOverlay() {
		return this;
	}
	
	
}