package org.playonline.ui.basic.map.overlay;

import java.util.ArrayList;

import org.playonline.ui.basic.R;
import org.playonline.ui.basic.map.PlayOnlineMapActivity;

import android.graphics.drawable.Drawable;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;


public class OtherCharacterOverlay extends ItemizedOverlay<OverlayItem> implements CharacterOverlay{

	private static int MARKER = R.drawable.ic_maps_indicator_other_player_position;
	
	private final ArrayList<OverlayItem> mOverlays;
	private final PlayOnlineMapActivity mapActivity;
	private final GeoPoint 	playerLocation;

	
	public OtherCharacterOverlay(PlayOnlineMapActivity mapActivity, GeoPoint location) {
		super(boundCenterBottom(mapActivity.getResources().getDrawable(MARKER)));
		mOverlays = new ArrayList<OverlayItem>();
		this.mapActivity = mapActivity;
		this.playerLocation = location;
		OverlayItem overlayItem = new OverlayItem(playerLocation, "", "");
		this.addOverlay(overlayItem);
	}

	public void addOverlay(OverlayItem overlay) {
		mOverlays.add(overlay);
		populate();
	}

	@Override
	protected OverlayItem createItem(int i) {
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		return mOverlays.size();
	}

	@Override
	protected boolean onTap(int index) {
		// only if character is alone
		if(!mapActivity.getCharacter().isAttachedToLeader()){
			// display dialog allowing user to travel to the location pressed
			mapActivity.getMapViewDialogsManager().displayTravelDialogToStandardLocation(playerLocation);
		}
		return true;
	}


	public GeoPoint getLocation(){
		return playerLocation;
	}


	public void setAlpha(int alpha){
		Drawable marker = mapActivity.getResources().getDrawable(R.drawable.ic_maps_indicator_other_player_position);
		marker.setAlpha(alpha);
		boundCenterBottom(marker);
	}
	

	public ItemizedOverlay<OverlayItem> getItemizedOverlay() {
		return this;
	}
}
