package org.playonline.ui.basic.profile;


public class Character {

	private static final short	NOT_ATTACHED_TO_ANOTHER_CHARACTER = -1;
	private static final short	DEFAULT_TRANSPORT_POINTS = 100;

	private String 	name;
	private boolean isAttachedToLeader;
	private short	leaderActorSessionID;
	private short	transportPoints;

	private Character() {
		this.isAttachedToLeader = false;
		this.leaderActorSessionID = NOT_ATTACHED_TO_ANOTHER_CHARACTER;
		this.transportPoints = DEFAULT_TRANSPORT_POINTS;
	}

	public static Character getInstance() {
		return new Character();
	}

	public static Character getInstance(String name) {
		Character character = new Character();
		character.name = name;
		return character;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public boolean isAttachedToLeader() {
		return isAttachedToLeader;
	}
	
	
	public short getTransportPoints() {
		return transportPoints;
	}
	
	
	public void setTransportPoints(short points){
		this.transportPoints = points;
	}


	/**
	 * 
	 * @return -1 if character is not attached to another character.
	 */
	public short getLeaderActorSessionID() {
		return leaderActorSessionID;
	}


	public void attachToLeader(short leaderActorSessionID) {
		this.isAttachedToLeader 	= true;
		this.leaderActorSessionID 	= leaderActorSessionID;
	}
	
	
	public void detachFromLeader(){
		this.isAttachedToLeader 	= false;
		this.leaderActorSessionID 	= NOT_ATTACHED_TO_ANOTHER_CHARACTER;
	}
	
	
	@Override
	public String toString() {
		String string = new String();
		string += name;
		if(isAttachedToLeader){
			string += " - attached to "+leaderActorSessionID;
		}else{
			string += " - not attached to any character";
		}
		return string;
	}
}
